#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Mar 12 18:46:52 2019

@author: gilles
"""

###############
# Exercice 1 #
##############

""" Fonction nombreDiviseurs(n : entier; nb : entier)
n : entier dont on veut connaître le nombre de diviseurs
renvoie nb, le nombre de diviseurs de n """


def nombreDiviseurs(n):
    nb=0
    for i in range(1,n+1):
        if n%i==0:
            nb=nb+1
    return nb
    

""" Fonction troisDiviseurs(annee1 : entier; annee2 : entier)
annee1 : l'année de départ de la recherche
d : entier, le nombre de diviseur de annee
renvoie annee2, l'année suivant celle de départ qui comporte trois diviseurs """

def troisDiviseurs(annee1):
    annee2=annee1
    d=nombreDiviseurs(annee2)
    while d!=3:
        annee2=annee2+1
        d=nombreDiviseurs(annee2)
    return annee2


###############
# Exercice 2 #
##############
    
from math import sqrt

""" Fonction carreParfait(n : entier;  booléen)
n : nombre pour lequel on veut savoir si c'est un carré parfait
renvoie True si n est un carré parfait, False sinon """

def carreParfait(n):
    dec=sqrt(n)-int(sqrt(n))
    return (dec<0.0000001)

""" Fonction probaCarresParfaits(;flottant)
h : entier, le numéro de l’heure
m : entier, le nombre de minutes
nbcarres : entier, le nombre de carres parfaits entre 2230 et 2359 puis entre 0 et 730
renvoie un flottant, donnant la proportion de carres parfaits  """

def probaCarresParfaits():
    h=22
    m=30    
    nbcarres=0
    while h!=7:
        if carreParfait(h*100+m):
            nbcarres+=1
        m+=1
        if m==60:
            h+=1
            m=0
            if h==24:
                h=0
    return nbcarres/860

###############
# Exercice 3 #
#############
    
""" Fonction niemeChiffre(n : entier; entier)
n : numéro du chiffre cherché
nb : chaîne, contient la suite des carrés des entiers naturels non nuls consécutifs 
i : entier, nombre dont on calcule le carré
renvoie le carré du dernier entier calculé """

def niemeChiffre(n):
    nb="1"
    i=1
    while len(nb)<n:
        i=i+1
        nb=nb+str(i**2)
    return i**2


##############
# Exercice 4 #
#############
    
""" Fontion miroir(ch : chaîne; chaîne)
ch : texte dont on veut le miroir
renvoie le texte miroir de ch """

def miroir(ch):
    if len(ch)==1:
        return ch
    else :
        return miroir(ch[1:])+ch[0]
    
""" Fonction palidrome(ch : chaîne, booléen)
ch : chaîne dont on veut savoir si elle est son propre miroir  
renvoie True si ch est un palindrome, False sinon """  

def palindrome(ch):
    return ch==miroir(ch)

""" Fonction Lychrel(n : entier; i :entier)
n : nombre dont on veut savoir si c'est un nombre de Lychrel
renvoie i, le nombre d'étapes nécessaires pour transformer n en un nombre palindrome """

def Lychrel(n):
    if n<10:
        return 0
    else :
        i=0
        while not(palindrome(str(n))):
            n=n+eval(miroir(str(n)))
            i+=1
        return i

###############
# Exercice 5 #
#############
        
""" Fontion multiplicationChiffres(n : entier; prod : entier)
n : nombre dont on veut multiplier les chiffres
r : chiffre des unités de n, à chaque étape
renvoie prod, le produit des chiffres de n """
    
def multiplicationChiffres(n):
    r=n%10
    prod=r
    while n>10:
        n=n//10
        r=n%10
        prod=prod*r
    return prod

""" Fontion persistance(n : entier; i : entier)
n : nombre dont on veut connaître la persistance
renvoie i, la persistace multiplicative de n"""

def persistance(n):
    if n<10:
        return 0
    else:
        i=0
        while n>10:
            n=multiplicationChiffres(n)
            i=i+1
        return i